<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>Git and Gitlab command line :: Testsite - experimenting with Antora</title>
    <link rel="canonical" href="https://digdir.gitlab.io/test/antora-demo/home/tools/siste/git/gitlab-commandline.html">
    <meta name="generator" content="Antora 2.2.0">
    <link rel="stylesheet" href="../../../_/css/site.css">
  </head>
  <body class="article">
<header class="header">
  <nav class="navbar">
    <div class="navbar-brand">
      <a class="navbar-item" href="https://digdir.gitlab.io/test/antora-demo/home">Testsite - experimenting with Antora</a>
      <button class="navbar-burger" data-target="topbar-nav">
        <span></span>
        <span></span>
        <span></span>
      </button>
    </div>
    <div id="topbar-nav" class="navbar-menu">
      <div class="navbar-end">
        <div class="navbar-item has-dropdown is-hoverable">
          <a class="navbar-link" href="#">Valg</a>
          <div class="navbar-dropdown">
            <a class="navbar-item" href="#">Rolle</a>
            <a class="navbar-item" href="#">Preferanser</a>
            <a class="navbar-item" href="#">Språk</a>
          </div>
        </div>
        <div class="navbar-item has-dropdown is-hoverable">
          <a class="navbar-link" href="#">Ressurser</a>
          <div class="navbar-dropdown">
            <a class="navbar-item" href="#">Verktøy</a>
            <a class="navbar-item" href="#">Kunnskapsbibliotek</a>
          </div>
        </div>	
        <div class="navbar-item has-dropdown is-hoverable">
          <a class="navbar-link" href="#">Hjelp</a>
          <div class="navbar-dropdown">
            <a class="navbar-item" href="#">Om NEAR-NO</a>
            <a class="navbar-item" href="#">FAQ</a>
          </div>
        </div>
		<a id="twitter-link" class="navbar-item" href="https://twitter.com/janakaSteph" target="_blank">
          <i class="fab fa-twitter"></i>
        </a>
      </div>
    </div>
  </nav>
</header>
<div class="body">
<div class="nav-container" data-component="tools" data-version="2.0">
  <aside class="nav">
    <div class="panels">
<div class="nav-panel-menu is-active" data-panel="menu">
  <nav class="nav-menu">
    <h3 class="title"><a href="../index.html">Tools</a></h3>
<ul class="nav-list">
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="../index.html">Tools start page</a>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <button class="nav-item-toggle"></button>
    <span class="nav-text">git</span>
<ul class="nav-list">
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="git-introduction.html">Introduction</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="git-installation.html">Installation</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="git-conventions.html">Usage conventions</a>
  </li>
</ul>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <button class="nav-item-toggle"></button>
    <span class="nav-text">Antora</span>
<ul class="nav-list">
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../antora/antora-introduction.html">Introduction</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../antora/antora-installation.html">Installation</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../antora/antora-conventions.html">Usage conventions</a>
  </li>
</ul>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <button class="nav-item-toggle"></button>
    <span class="nav-text">Archi</span>
<ul class="nav-list">
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../archi/archi-introduction.html">Introduction</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../archi/archi-installation.html">Installation</a>
  </li>
  <li class="nav-item" data-depth="2">
    <a class="nav-link" href="../archi/archi-conventions.html">Usage conventions</a>
  </li>
</ul>
  </li>
</ul>
  </li>
</ul>
  </nav>
</div>
<div class="nav-panel-explore" data-panel="explore">
  <div class="context">
    <span class="title">Tools</span>
    <span class="version">2.0</span>
  </div>
  <ul class="components">
    <li class="component">
      <span class="title">Component A</span>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../component-a/1.5.6/inline-text-formatting.html">1.5.6</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <span class="title">Component B</span>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../component-b/2.0/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component is-current">
      <span class="title">Tools</span>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../siste/index.html">siste</a>
        </li>
        <li class="version is-current">
          <a href="../index.html">2.0</a>
        </li>
        <li class="version">
          <a href="../../1.0/index.html">1.0</a>
        </li>
      </ul>
    </li>
  </ul>
</div>
    </div>
  </aside>
</div>
<main>
<div class="toolbar" role="navigation">
<button class="nav-toggle"></button>
  <a href="../../siste/index.html" class="home-link"></a>
<nav class="breadcrumbs" aria-label="breadcrumbs">
  <ul>
    <li><a href="../index.html">Tools</a></li>
    <li><a href="gitlab-commandline.html">Git and Gitlab command line</a></li>
  </ul>
</nav>
<div class="page-versions">
  <button class="version-menu-toggle" title="Show other versions of page">2.0</button>
  <div class="version-menu">
    <a class="version" href="../../siste/git/gitlab-commandline.html">siste</a>
    <a class="version is-current" href="gitlab-commandline.html">2.0</a>
    <a class="version is-missing" href="../../1.0/index.html">1.0</a>
  </div>
</div>
  <div class="edit-this-page"><a href="https://gitlab.com/digdir/test/antora-demo/tools/edit/v2.0/docs/modules/git/pages/gitlab-commandline.adoc">Rediger kilde</a></div>
  </div>
<article class="doc"><a name="section-top"></a>
<h1 class="page">Git and Gitlab command line</h1>
<div class="sect1">
<h2 id="_prerequisites_windows_10"><a class="anchor" href="#_prerequisites_windows_10"></a>Prerequisites (Windows 10)</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_gitbash_shell_installed"><a class="anchor" href="#_gitbash_shell_installed"></a>Gitbash shell installed</h3>
<div class="paragraph">
<p>Download and install Gitbash App from  <a href="https://gitforwindows.org/" class="bare">https://gitforwindows.org/</a></p>
</div>
</div>
<div class="sect2">
<h3 id="_open_gitbash_shell"><a class="anchor" href="#_open_gitbash_shell"></a>Open Gitbash shell</h3>
<div class="paragraph">
<p>Start Gitbash App</p>
</div>
</div>
<div class="sect2">
<h3 id="_verify_your_git_installation"><a class="anchor" href="#_verify_your_git_installation"></a>Verify your git installation</h3>
<div class="paragraph">
<p>git --version</p>
</div>
</div>
<div class="sect2">
<h3 id="_verify_git_user"><a class="anchor" href="#_verify_git_user"></a>Verify git user</h3>
<div class="literalblock">
<div class="content">
<pre>git config --global user.name</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_verify_git_email"><a class="anchor" href="#_verify_git_email"></a>Verify git email</h3>
<div class="literalblock">
<div class="content">
<pre>git config --global user.email</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_install_jq_json_command_line_processor"><a class="anchor" href="#_install_jq_json_command_line_processor"></a>Install jq Json command line processor</h3>
<div class="paragraph">
<p>Run Powershell as administrator and install as follows:</p>
</div>
<div class="literalblock">
<div class="content">
<pre>PS C:\WINDOWS\system32&gt;chocolatey install jq</pre>
</div>
</div>
<div class="paragraph">
<p>Ref. <a href="https://stedolan.github.io/jq/download/" class="bare">https://stedolan.github.io/jq/download/</a></p>
</div>
</div>
<div class="sect2">
<h3 id="_install_curl"><a class="anchor" href="#_install_curl"></a>Install curl</h3>
<div class="paragraph">
<p>See <a href="https://curl.haxx.se/windows/" class="bare">https://curl.haxx.se/windows/</a></p>
</div>
<div class="paragraph">
<p>Also see <a href="https://develop.zendesk.com/hc/en-us/articles/360001068567-Installing-and-using-cURL" class="bare">https://develop.zendesk.com/hc/en-us/articles/360001068567-Installing-and-using-cURL</a></p>
</div>
<div class="literalblock">
<div class="content">
<pre>Essence: Download curl and copy the three binaries to c:/curl, then add c:/curl to the system path.</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_git_ssh_key_pair_move_from_here_to_general_git_setup"><a class="anchor" href="#_git_ssh_key_pair_move_from_here_to_general_git_setup"></a>git SSH key pair (move from here to general git setup)</h3>
<div class="paragraph">
<p>Ref. <a href="https://gitlab.com/help/ssh/README#generating-a-new-ssh-key-pair" class="bare">https://gitlab.com/help/ssh/README#generating-a-new-ssh-key-pair</a></p>
</div>
<div class="literalblock">
<div class="content">
<pre>ssh-keygen -t ed25519 -C "erik.hagen@digdir.no"</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_personal_access_token"><a class="anchor" href="#_personal_access_token"></a>Personal access token</h3>
<div class="paragraph">
<p>Add a personal access token, if you don&#8217;t have one already:</p>
</div>
<div class="paragraph">
<p>See <a href="https://gitlab.com/profile/personal_access_tokens" class="bare">https://gitlab.com/profile/personal_access_tokens</a></p>
</div>
<div class="paragraph">
<p>You will need this for API commands starting with</p>
</div>
<div class="literalblock">
<div class="content">
<pre>_curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72"_</pre>
</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_selected_git_commands"><a class="anchor" href="#_selected_git_commands"></a>Selected git commands</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Ref. <a href="https://docs.gitlab.com/ee/gitlab-basics/start-using-git.html" class="bare">https://docs.gitlab.com/ee/gitlab-basics/start-using-git.html</a></p>
</div>
<div class="literalblock">
<div class="content">
<pre>cd /c/gitlab
mkdir erik-hagen
cd /c/gitlab/erik-hagen
mkdir nsb
cd /c/gitlab/erik-hagen/nsb
mkdir common
mkdir components</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>mkdir components/architecture-landscape</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>//
// Script starting here
//</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>// PRIVATE_TOKEN="Wu2zJXeohr1ZYeCG5M72"
PRIVATE_TOKEN="F6nUq1nvsCJUVpRYe9L3"</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>ROOT_GROUP_NAME="NER Norway"
ROOT_GROUP_PATH="ner-norway"
ROOT_GROUP_ID="6835396"</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>cd /c/gitlab/
mkdir $ROOT_GROUP_PATH
cd /c/gitlab/$ROOT_GROUP_PATH</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>GROUPNAME="Components"
GROUPPATH="components"
DESCRIPTION="Antora%20components of " $ROOT_GROUP_NAME</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>mkdir $GROUPPATH</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>//create the gitlab group
curl -s --header "PRIVATE-TOKEN: $PRIVATE_TOKEN" -X POST "https://gitlab.com/api/v4/groups?name=$GROUPNAME&amp;path=$GROUPPATH&amp;parent_id=$ROOT_GROUP_ID&amp;visibility=public&amp;lfs_enabled=true&amp;description=$DESCRIPTION" | jq &gt;group_$GROUPPATH.txt</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>// find the new group id
GROUP_ID=$(grep -w "id" group_$GROUPPATH.txt | grep -Eo "[[:digit:]]+")
echo "ID of new group ($GROUPNAME): " $GROUP_ID</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>// Delete the new group
//curl -s --header "PRIVATE-TOKEN: $PRIVATE_TOKEN"  -X DELETE "https://gitlab.com/api/v4visibi&amp;path=lity=public/groups/$GROUP_ID" | jq</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>//
//
//
PRIVATE_TOKEN="F6nUq1nvsCJUVpRYe9L3"
ROOT_GROUP_NAME="NER%20Norway"
ROOT_GROUP_PATH="ner-norway"
ROOT_GROUP_ID="6835396"</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>GROUPPATH=ROOT_GROUP_PATH
PROJECTNAME="Common"
PROJECTPATH="common"
DESCRIPTION="Common%20files"</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>#create top level project common
curl --header "PRIVATE-TOKEN: $PRIVATE_TOKEN" -X POST "https://gitlab.com/api/v4/projects?name=$PROJECTNAME&amp;path=$PROJECTPATH&amp;description=$DESCRIPTION&amp;visibility=public" | jq &gt;project_$GROUPPATH_$PROJECTPATH.txt</pre>
</div>
</div>
<div class="paragraph">
<p>curl --header "PRIVATE-TOKEN: $PRIVATE_TOKEN" -X POST "https://gitlab.com/api/v4/projects?name=$PROJECTNAME&amp;path=$PROJECTPATH&amp;visibility=public" | jq</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_gitlab_api"><a class="anchor" href="#_gitlab_api"></a>Gitlab api</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_list_all_my_groups"><a class="anchor" href="#_list_all_my_groups"></a>List all my groups</h3>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>With private token for authentication:</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" https://gitlab.com/api/v4/groups | jq</pre>
</div>
</div>
</li>
<li>
<p>With username/password  for authentication:</p>
<div class="literalblock">
<div class="content">
<pre>curl -u {erik.hagen@digdir.no}:{#7Wonders} https://gitlab.com/api/v4/groups | jq</pre>
</div>
</div>
</li>
<li>
<p>No authentication:</p>
<div class="literalblock">
<div class="content">
<pre>curl https://gitlab.com/api/v4/groups | jq</pre>
</div>
</div>
</li>
<li>
<p>Order and sort by path</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups?order_by=path&amp;sort=asc" | jq | grep path</pre>
</div>
</div>
</li>
<li>
<p>Sort by name:</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" https://gitlab.com/api/v4/groups?sort=asc | jq | grep name</pre>
</div>
</div>
</li>
<li>
<p>Sort by web_url using linux sort and grep:</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups" | jq | sort | grep -i "web_url"</pre>
</div>
</div>
</li>
<li>
<p>Output to file and filter by grep (1 line before and 2 after each grep match):</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups" | jq &gt; groups.txt</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>grep "/erik-hagen" groups.txt -B1 -A2</pre>
</div>
</div>
</li>
</ol>
</div>
</div>
<div class="sect2">
<h3 id="_list_subgroups_of_group_with_given_id"><a class="anchor" href="#_list_subgroups_of_group_with_given_id"></a>List subgroups of group with given id</h3>
<div class="literalblock">
<div class="content">
<pre>curl https://gitlab.com/api/v4/groups/6815654/subgroups | jq | grep name_with_namespace</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_list_details_of_given_group"><a class="anchor" href="#_list_details_of_given_group"></a>List details of given group</h3>
<div class="olist arabic">
<ol class="arabic">
<li>
<p>With projects (default):</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups/6815605" | jq</pre>
</div>
</div>
</li>
<li>
<p>Without projects:</p>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups/6815605?with_projects=false" | jq</pre>
</div>
</div>
</li>
</ol>
</div>
</div>
<div class="sect2">
<h3 id="_list_projects_of_group_with_given_id"><a class="anchor" href="#_list_projects_of_group_with_given_id"></a>List projects of group with given id</h3>
<div class="literalblock">
<div class="content">
<pre>curl https://gitlab.com/api/v4/groups/6815655/projects?sort=asc | jq | grep name_with_namespace</pre>
</div>
</div>
<div class="paragraph">
<p>With subgroups:</p>
</div>
<div class="literalblock">
<div class="content">
<pre>curl "https://gitlab.com/api/v4/groups/6815605/projects?include_subgroups=true&amp;sort=asc" | jq | grep name_with_namespace</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_create_a_new_subgroup"><a class="anchor" href="#_create_a_new_subgroup"></a>Create a new subgroup</h3>
<div class="admonitionblock warning">
<table>
<tr>
<td class="icon">
<i class="fa icon-warning" title="Warning"></i>
</td>
<td class="content">
TODO: Add visibility=private / internal / public and lfs_enabled&#8230;&#8203; ref. <a href="https://docs.gitlab.com/ee/api/groups.html" class="bare">https://docs.gitlab.com/ee/api/groups.html</a>
</td>
</tr>
</table>
</div>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" -X POST "https://gitlab.com/api/v4/groups?name=Testgroup1&amp;path=testgroup1&amp;parent_id=6831516" | jq</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" -X POST "https://gitlab.com/api/v4/groups?name=Testgroup2&amp;path=testgroup2&amp;parent_id=6834958" | jq</pre>
</div>
</div>
<div class="literalblock">
<div class="content">
<pre>curl -s --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" -X POST "https://gitlab.com/api/v4/groups?name=Testgroup2&amp;path=testgroup2&amp;parent_id=6834958&amp;visibility=private&amp;lfs_enabled=true" | jq</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_update_a_group"><a class="anchor" href="#_update_a_group"></a>Update a group</h3>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<i class="fa icon-note" title="Note"></i>
</td>
<td class="content">
Assuming group with id=6834958 exists
</td>
</tr>
</table>
</div>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" -X PUT "https://gitlab.com/api/v4/groups/6834958?name=Testgroup%201&amp;path=testgroup-1" | jq</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_delete_a_group"><a class="anchor" href="#_delete_a_group"></a>Delete a group</h3>
<div class="literalblock">
<div class="content">
<pre>curl -s --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72"  -X DELETE "https://gitlab.com/api/v4/groups/6835117" | jq</pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_search_for_group"><a class="anchor" href="#_search_for_group"></a>Search for group</h3>
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<i class="fa icon-note" title="Note"></i>
</td>
<td class="content">
Searching name and path only (not web_url).
</td>
</tr>
</table>
</div>
<div class="literalblock">
<div class="content">
<pre>curl --header "PRIVATE-TOKEN: Wu2zJXeohr1ZYeCG5M72" "https://gitlab.com/api/v4/groups?search=erik-hagen" | jq</pre>
</div>
</div>
</div>
</div>
</div>
</article>
<aside class="article-aside hidden" role="navigation">
  <h3 class="toc-title">Innhold</h3>
  <div id="article-toc"></div>
</aside></main>
</div>
<footer class="footer">
  <p>This page was built using the Antora default UI.</p>
  <p>The source code for this UI is licensed under the terms of the MPL-2.0 license.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/tocbot/4.1.1/tocbot.min.js"></script>
<script src="../../../_/js/site.js"></script>
<script src="../../../_/js/vendor/highlight.js"></script>
<script>hljs.initHighlighting()</script>
<script>
  tocbot.init( {
                  tocSelector: '#article-toc',
                  contentSelector: 'article',
                  headingSelector: 'h2, h3, h4, h5, h6',
                  collapseDepth: 6,
                  positionFixedSelector: '#article-toc',
                  scrollSmooth: false
                } );
  var tocList = document.getElementById( 'article-toc' ).getElementsByClassName( 'toc-list' );
  if ( tocList && tocList.length > 0 && tocList[0].childNodes.length > 0 ) {
    document.getElementById( 'article-toc' ).parentNode.classList.remove( 'hidden' );
  }
</script>  </body>
</html>
